Push Update AddOn für REDAXO 4
============================

Website-Inhalte werden aktualisiert, ohne dass die Seite neu geladen werden muss. Damit lassen sich beispielsweise Liveticker realisieren.

Unterstützt werden folgende Aktionen:
-------------------------------------

* Article-Slice hinzufügen
* Article-Slice: Inhalt ändern
* Article-Slice: Reihenfolge ändern
* Article-Slice löschen

Als Push-Server kann Node.js mit Socket.IO oder Pusher.com verwendet werden.

Das Addon ist eine Betaversion und nicht zum Produktiveinsatz empfohlen.


Einfacher Socketserver mit node.js / socket.io
----------------------------------------------

```js
/**
 * Simple socketserver with node.js / socket.io
 *
 * @author Michael Ziem, www.ziem.io
 */

/**
 * Required packages
 */
var server = require('http').createServer(),
    io = require('socket.io')(server);

io.on('connection', function (socket) {

    'use strict';

    /**
     * New client connected
     */
    console.log('> connected');

    /**
     * Send data to all connected clients
     */
    socket.on('event', function (data) {
        console.log('>>> ' + data);
        socket.broadcast.emit('event', data);
    });

    /**
     * Client disconnected
     */
    socket.on('disconnect', function () {
        console.log('> disconnected');
    });

});

/**
 * Listen on port
 */
server.listen(3000);

/**
 * Server started
 * Start Server with: "nohup node node-js-socket-server.js &"
 */
console.log('Server started on port 3000');

```

Hinweise
--------

* Getestet mit REDAXO 4.6.1
* AddOn-Ordner lautet: `pushupdate`

Changelog
---------

siehe [CHANGELOG.md](CHANGELOG.md)

Lizenz
------

siehe [LICENSE.md](LICENSE.md)

Credits
-------

* [Parsedown](http://parsedown.org/) Class by Emanuil Rusev
