<?php
class rex_pushupdate {

    // Cookie für Authentifizierung setzen
    public static function setAuthCookie() {
    
        $hash = self::getUniqueHash();
        setcookie('rex-1215-auth', $hash);
    }
    
    // Wrapper um Content Slice
    public static function addSliceWrapper($params) {
    
        $slice = OOArticleSlice::getArticleSliceById($params['slice_id'], $params['clang']);
        
        $params['updatedate'] = $slice->getValue('updatedate');
    
        $sliceContent = '<span class="pu-1215-slice-wrapper" id="pu-1215-slice-'.$params['slice_id'].'-'.$params['clang'].'" data-updatetime="'.$params['updatedate'].'">';
        $sliceContent .= $params['subject'];
        $sliceContent .= '</span>';
    
        return $sliceContent;
    }
    
    // Wrapper um Artikel
    public static function addArticleWrapper($params) {
    
        $sliceArticle = '<span class="pu-1215-article-wrapper" id="pu-1215-article-'.$params['article']->article_id.'-'.$params['article']->ctype.'-'.$params['article']->clang.'">';
        $sliceArticle .= $params['subject'];
        $sliceArticle .= '</span>';
    
        return $sliceArticle;
    }
    
    // Javascript einfügen
    public static function addJS($params) {
	
		global $REX;
		
		if(!in_array($REX['ADDON']['pushupdate']['settings']['socket'], array('socketio', 'pushercom'))) {
		    return;
		}

        $insert = PHP_EOL;
        $insert .= "\t" . '<!-- BEGIN AddOn Push Update -->' . PHP_EOL;
        $insert .= "\t" . '<script src="' . $REX['HTDOCS_PATH'] . 'files/addons/pushupdate/pushupdate.js"></script>' . PHP_EOL;
		
		if($REX['ADDON']['pushupdate']['settings']['socket'] == 'socketio') {
        
            $insert .= "\t" . '<script src="//' . $REX['ADDON']['pushupdate']['settings']['socketiourl'] . ':' . $REX['ADDON']['pushupdate']['settings']['socketioport'] . '/socket.io/socket.io.js"></script>' . PHP_EOL;
            $insert .= "\t" . '<script>' . PHP_EOL;
            $insert .= "\t\t" . 'var pu = Object.create(PUSHUPDATE);' . PHP_EOL;
            $insert .= "\t\t" . 'pu.initSocketIO({' . PHP_EOL;
            $insert .= "\t\t\t" . 'socketUrl: \'' . $REX['ADDON']['pushupdate']['settings']['socketiourl'] . ':' . $REX['ADDON']['pushupdate']['settings']['socketioport'] . '\',' . PHP_EOL;
            $insert .= "\t\t\t" . 'callback: function(params) {' . PHP_EOL;
            $insert .= "\t\t\t\t" . 'pu.log(this);' . PHP_EOL;
            $insert .= "\t\t\t" . '}' . PHP_EOL;
            $insert .= "\t\t" . '});' . PHP_EOL;
            $insert .= "\t" . '</script>' . PHP_EOL;
            
        } elseif($REX['ADDON']['pushupdate']['settings']['socket'] == 'pushercom') {
        
            $insert .= "\t" . '<script src="//js.pusher.com/2.2/pusher.min.js"></script>' . PHP_EOL;
            $insert .= "\t" . '<script>' . PHP_EOL;
            $insert .= "\t\t" . 'var pu = Object.create(PUSHUPDATE);' . PHP_EOL;
            $insert .= "\t\t" . 'pu.initPusher({' . PHP_EOL;
            $insert .= "\t\t\t" . 'key: \'' . $REX['ADDON']['pushupdate']['settings']['pushercomappkey'] . '\',' . PHP_EOL;
            $insert .= "\t\t\t" . 'channel: \'' . $REX['ADDON']['pushupdate']['settings']['pushercomchannel'] . '\',' . PHP_EOL;
            $insert .= "\t\t\t" . 'callback: function(params) {' . PHP_EOL;
            $insert .= "\t\t\t\t" . 'pu.log(this);' . PHP_EOL;
            $insert .= "\t\t\t" . '}' . PHP_EOL;
            $insert .= "\t\t" . '});' . PHP_EOL;
            $insert .= "\t" . '</script>' . PHP_EOL;
        }
        
        $insert .= "\t" . '<!-- END AddOn Push Update -->' . PHP_EOL;
		
		return str_replace('</body>', $insert . '</body>', $params['subject']);
	}
    

    // Neuer Artikel-Slice angelegt
    public static function sliceAdded($params) {
    
        // Get content an Re Slice from Slice
        $slice = OOArticleSlice::getArticleSliceById($params['slice_id'], $params['clang']);
        $content = $slice->getSlice();
        
        $re_slice_id = intVal($slice->getValue('re_article_slice_id'));
        
        if($re_slice_id != 0) {
            // Überprüfen, ob der Slice re_slice_id in der richtige Spalte liegt
            $re_slice = OOArticleSlice::getArticleSliceById($re_slice_id, $params['clang']);
            $re_slice_ctype = intVal($re_slice->getCtype());
        
            if($params['ctype'] != $re_slice_ctype) {
                $re_slice_id = 0;
            }
        }
        
        // Pack message
        $payload = new stdClass();
        $payload->auth = self::getUniqueHash();
        $payload->action = 'slice_add';
        $payload->timestamp = time();
        $payload->article_id = $params['article_id'];
        $payload->ctype = $params['ctype'];
        $payload->slice_id = $params['slice_id'];
        $payload->re_slice_id = empty($re_slice_id) ? 0 : $re_slice_id;
        $payload->clang = $params['clang'];
        $payload->content = $content;
            
        // Send message via socket
        self::sendSocket($payload);
    }

    // Inhalt in Artikel-Slice geändert
    public static function sliceContentUpdate($params) {

        global $REX;
    
        if(
            isset($REX['ACTION']) 
            && $REX['ACTION']['EVENT'] == 'EDIT' 
            && $REX['ACTION']['SAVE'] == true 
            && $REX['ACTION']['SLICE_ID'] == $params['slice_id']
        ) {
    
            // Get content from Slice
            $slice = OOArticleSlice::getArticleSliceById($REX['ACTION']['SLICE_ID'], $REX['ACTION']['CLANG_ID']);
            $sliceContent = $slice->getSlice();
            
            // Pack message
            $payload = new stdClass();
            $payload->auth = self::getUniqueHash();
            $payload->action = 'slice_update';
            $payload->timestamp = time();
            $payload->article_id = $params['article_id'];
            $payload->ctype = intVal($params['ctype']);
            $payload->slice_id = intVal($params['slice_id']);
            $payload->clang = $params['clang'];
            $payload->content = $sliceContent;
            
            // Send message via socket
            self::sendSocket($payload);
        }
    }
    
    // Artikel-Slice gelöscht
    public static function sliceDelete($params) {

        // Pack message
        $payload = new stdClass();
        $payload->auth = self::getUniqueHash();
        $payload->action = 'slice_delete';
        $payload->timestamp = time();
        $payload->article_id = $params['article_id'];
        $payload->ctype = $params['ctype'];
        $payload->slice_id = $params['slice_id'];
        $payload->clang = $params['clang'];
    
        // Send message via socket
        self::sendSocket($payload);
    }
    
    // Artikel-Slice Reihenfolge geändert
    public static function sliceUpdate($params) {

        global $REX;
    
        $function = rex_request('function');
   
        if(
            in_array($function, array('moveup', 'movedown')) 
            && empty($params['article']->warning)
        ) {
    
            // Move Slice
            $slice_id = $params['article']->slice_id;
            $clang = $params['article']->clang;
        
            $sql = rex_sql::factory();
            $sql->setQuery('
                SELECT re_article_slice_id FROM ' . $REX['TABLE_PREFIX'] . 'article_slice 
                WHERE ' . $REX['TABLE_PREFIX'] . "article_slice.id = '$slice_id' 
                AND clang = $clang"
            );
        
            $re_slice_id = intVal($sql->getValue($REX['TABLE_PREFIX'] . 'article_slice.re_article_slice_id'));
        
            $payload = new stdClass();
            $payload->auth = self::getUniqueHash();
            $payload->action = $function == 'moveup' ? 'slice_moveup' : 'slice_movedown';
            $payload->timestamp = time();
            $payload->article_id = $params['article']->article_id;
            $payload->ctype = $params['article']->ctype;
            $payload->slice_id = $slice_id;
            $payload->re_slice_id = empty($re_slice_id) ? 0 : $re_slice_id;
            $payload->clang = $clang;
    
            self::sendSocket($payload);
        }
    }
    
    public static function sendSocket($payload) {

        global $REX;
        
        if($REX['ADDON']['pushupdate']['settings']['socket'] == 'socketio') {
            self::sendSocketIO($payload);
        } elseif($REX['ADDON']['pushupdate']['settings']['socket'] == 'pushercom') {
            self::sendPusher($payload);
        }
    }

    public static function sendSocketIO($payload) {

        global $REX;
    
        $json = json_encode($payload, JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE);
        
        $socketio = new SocketIO();
    
        if ($socketio->send($REX['ADDON']['pushupdate']['settings']['socketiourl'], $REX['ADDON']['pushupdate']['settings']['socketioport'], 'event', $json)) {
            error_log('we sent the message and disconnected', 3, 'log.txt');
        } else {
            error_log('Sorry, we have a mistake :(', 3, 'log.txt');
        }
    }
    
    public static function sendPusher($payload) {

        global $REX;

        $app_id = $REX['ADDON']['pushupdate']['settings']['pushercomappid'];
        $app_key = $REX['ADDON']['pushupdate']['settings']['pushercomappkey'];
        $app_secret = $REX['ADDON']['pushupdate']['settings']['pushercomappsecret'];

        $pusher = new Pusher($app_key, $app_secret, $app_id);

        $data['message'] = $payload;
        $pusher->trigger($REX['ADDON']['pushupdate']['settings']['pushercomchannel'], 'event', $data);
    }
	
	public static function getUniqueHash() {
		global $REX;
		
		return md5($REX['DB']['1']['HOST'].$REX['DB']['1']['NAME'].$REX['TABLE_PREFIX']);
	}
}