<?php

// Init Addon
$REX['ADDON']['name']['pushupdate'] = 'Push Update';
$REX['ADDON']['rxid']['pushupdate'] = '1215';
$REX['ADDON']['perm']['pushupdate'] = 'pushupdate[]';

// Credits
$REX['ADDON']['version']['pushupdate'] = '0.2';
$REX['ADDON']['author']['pushupdate'] = 'Michael Ziem';
$REX['ADDON']['page']['pushupdate'] = 'www.ziem.io';
$REX['ADDON']['supportpage']['pushupdate'] = 'www.ziem.io';

// Permissions
$REX['PERM'][] = 'pushupdate[]';
$REX['PERM'][] = 'pushupdate[send]';

// add lang file
if($REX['REDAXO']) {
    $I18N->appendFile($REX['INCLUDE_PATH'] . '/addons/pushupdate/lang/');
}

// includes
require($REX['INCLUDE_PATH'] . '/addons/pushupdate/classes/class.rex_pushupdate_utils.inc.php');

require($REX['INCLUDE_PATH'] . '/addons/pushupdate/classes/class.rex_pushupdate.inc.php');
require($REX['INCLUDE_PATH'] . '/addons/pushupdate/classes/socket.io.php');
require($REX['INCLUDE_PATH'] . '/addons/pushupdate/classes/Pusher.php');

// default settings (user settings are saved in data dir!)
$REX['ADDON']['pushupdate']['settings'] = array(
	'pushupdate' => 0,

	'socket' => '',
	'socketiourl' => '',
	'socketioport' => '',

	'pushercomappid' => '',
	'pushercomappkey' => '',
	'pushercomappsecret' => '',
	'pushercomchannel' => ''
);

// overwrite default settings with user settings
rex_pushupdate_utils::includeSettingsFile();

if ($REX['REDAXO'] && is_object($REX['USER'])) {

	if ($REX['USER'] && $REX['USER']->isAdmin()) {
        // add subpages
        $REX['ADDON']['pushupdate']['SUBPAGES'] = array(
            array('', $I18N->msg('pushupdate_start')),
            array('settings', $I18N->msg('pushupdate_settings')),
            array('help', $I18N->msg('pushupdate_help'))
        );
    }
	
	if ($REX['USER'] && !$REX['USER']->isAdmin() && $REX['USER']->hasPerm('pushupdate[send]')) {
        $REX['ADDON']['pushupdate']['SUBPAGES'] = array(
            array('activate', $I18N->msg('pushupdate_settings'))
        );
	}
}

// Nur im Frontend
if(!$REX['REDAXO']) {
    
    // Cookie für Authentifizierung setzen
    rex_register_extension('OUTPUT_FILTER', 'rex_pushupdate::setAuthCookie');

    // Wrapper um Content Slice
    rex_register_extension('SLICE_SHOW', 'rex_pushupdate::addSliceWrapper');
    
    // Wrapper um Artikel
    rex_register_extension('ART_CONTENT', 'rex_pushupdate::addArticleWrapper');
    
    // Javascript einfügen
    rex_register_extension('OUTPUT_FILTER', 'rex_pushupdate::addJS');
}

// Nur im Backend
if($REX['REDAXO'] && $REX['USER'] && $REX['USER']->hasPerm('pushupdate[]') && $REX['USER']->hasPerm('pushupdate[send]')) {

    if($REX['ADDON']['pushupdate']['settings']['pushupdate'] == 1 || $REX['USER']->isAdmin()) {

        // Neuer Artikel-Slice angelegt
        rex_register_extension('SLICE_ADDED', 'rex_pushupdate::sliceAdded');

        // Inhalt in Artikel-Slice geändert
        rex_register_extension('ART_SLICE_MENU', 'rex_pushupdate::sliceContentUpdate');

        // Artikel-Slice gelöscht
        rex_register_extension('SLICE_DELETED', 'rex_pushupdate::sliceDelete');

        // Artikel-Slice Reihenfolge geändert
        rex_register_extension('ART_CONTENT', 'rex_pushupdate::sliceUpdate');
    
    }
}