/*jslint browser: true*/
/*global require, console*/

/**
 * Simple socketserver with node.js / socket.io
 *
 * @author Michael Ziem, www.ziem.io
 */

/**
 * Required packages
 */
var server = require('http').createServer(),
    io = require('socket.io')(server);

io.on('connection', function (socket) {

    'use strict';

    /**
     * New client connected
     */
    console.log('> connected');

    /**
     * Send data to all connected clients
     */
    socket.on('event', function (data) {
        console.log('>>> ' + data);
        socket.broadcast.emit('event', data);
    });

    /**
     * Client disconnected
     */
    socket.on('disconnect', function () {
        console.log('> disconnected');
    });

});

/**
 * Listen on port
 */
server.listen(3000);

/**
 * Server started
 * Start Server with: "nohup node node-js-socket-server.js &"
 */
console.log('Server started on port 3000');
