<?php

$page = rex_request('page', 'string');
$subpage = rex_request('subpage', 'string');
$func = rex_request('func', 'string');

// save settings
if ($func == 'update') {
	$settings = (array) rex_post('settings', 'array', array());

	rex_pushupdate_utils::replaceSettings($settings);
	rex_pushupdate_utils::updateSettingsFile();
}
?>

<div class="rex-addon-output">
	<div class="rex-form">

		<h2 class="rex-hl2"><?php echo $I18N->msg('pushupdate_settings'); ?></h2>

		<form action="index.php" method="post">

			<fieldset class="rex-form-col-1">
				<div class="rex-form-wrapper">
					<input type="hidden" name="page" value="<?php echo $page; ?>" />
					<input type="hidden" name="subpage" value="<?php echo $subpage; ?>" />
					<input type="hidden" name="func" value="update" />
					
                    <div class="rex-form-row rex-form-element-v1">
						<p class="rex-form-text">
							<label for="socket"><strong><?php echo $I18N->msg('pushupdate_settings_off'); ?></strong></label>
							<input class="rex-form-radio" type="radio" value="" name="settings[socket]" id="socket" 
							<?php echo $REX['ADDON']['pushupdate']['settings']['socket'] == '' ? 'checked="checked"' : ''; ?>
							>
						</p>
					</div>
					<div class="rex-form-row rex-form-element-v1">
						<p class="rex-form-text">
							<label for="socket"><strong><?php echo $I18N->msg('pushupdate_settings_socketio'); ?></strong></label>
							<input class="rex-form-radio" type="radio" value="socketio" name="settings[socket]" id="socket" 
							<?php echo $REX['ADDON']['pushupdate']['settings']['socket'] == 'socketio' ? 'checked="checked"' : ''; ?>
							>
						</p>
					</div>
					<div class="rex-form-row rex-form-element-v1">
						<p class="rex-form-text">
							<label for="socketiourl"><?php echo $I18N->msg('pushupdate_settings_socketio_url'); ?></label>
							<input type="text" value="<?php echo $REX['ADDON']['pushupdate']['settings']['socketiourl']; ?>" name="settings[socketiourl]" id="socketiourl" class="rex-form-text">
						</p>
					</div>
					<div class="rex-form-row rex-form-element-v1">
						<p class="rex-form-text">
							<label for="socketioport"><?php echo $I18N->msg('pushupdate_settings_socketio_port'); ?></label>
							<input type="text" value="<?php echo $REX['ADDON']['pushupdate']['settings']['socketioport']; ?>" name="settings[socketioport]" id="socketioport" class="rex-form-text">
						</p>
					</div>
					<!--
					<div class="rex-form-row rex-form-element-v1">
						<p class="rex-form-text">
                            <pre>
                                &lt;script src="<?php echo $REX['ADDON']['pushupdate']['settings']['socketiourl']; ?>:<?php echo $REX['ADDON']['pushupdate']['settings']['socketioport']; ?>/socket.io/socket.io.js"&gt;&lt;/script&gt;
                                &lt;script&gt;
                                    var pu = Object.create(PUSHUPDATE);
                                    pu.initSocketIO({
                                        socketUrl: '<?php echo $REX['ADDON']['pushupdate']['settings']['socketiourl']; ?>:<?php echo $REX['ADDON']['pushupdate']['settings']['socketioport']; ?>',
                                        callback: function(params) {
                                            //rexRT.log(this);
                                        }
                                    });
                                &lt;/script&gt;
                            </pre>
                        </p>
					</div>
					-->
                    <div class="rex-form-row rex-form-element-v1">
						<p class="rex-form-text">
							<label for="socket"><strong><?php echo $I18N->msg('pushupdate_settings_pushercom'); ?></strong></label>
							<input class="rex-form-radio" type="radio" value="pushercom" name="settings[socket]" id="socket" 
							<?php echo $REX['ADDON']['pushupdate']['settings']['socket'] == 'pushercom' ? 'checked="checked"' : ''; ?>
							>
						</p>
					</div>
                    <div class="rex-form-row rex-form-element-v1">
						<p class="rex-form-text">
							<label for="pushercomappid"><?php echo $I18N->msg('pushupdate_settings_pushercom_app_id'); ?></label>
							<input type="text" value="<?php echo $REX['ADDON']['pushupdate']['settings']['pushercomappid']; ?>" name="settings[pushercomappid]" id="pushercomappid" class="rex-form-text">
						</p>
					</div>
					<div class="rex-form-row rex-form-element-v1">
						<p class="rex-form-text">
							<label for="pushercomappkey"><?php echo $I18N->msg('pushupdate_settings_pushercom_app_key'); ?></label>
							<input type="text" value="<?php echo $REX['ADDON']['pushupdate']['settings']['pushercomappkey']; ?>" name="settings[pushercomappkey]" id="pushercomappkey" class="rex-form-text">
						</p>
					</div>
					<div class="rex-form-row rex-form-element-v1">
						<p class="rex-form-text">
							<label for="pushercomappsecret"><?php echo $I18N->msg('pushupdate_settings_pushercom_app_secret'); ?></label>
							<input type="text" value="<?php echo $REX['ADDON']['pushupdate']['settings']['pushercomappsecret']; ?>" name="settings[pushercomappsecret]" id="pushercomappsecret" class="rex-form-text">
						</p>
					</div>
					<div class="rex-form-row rex-form-element-v1">
						<p class="rex-form-text">
							<label for="pushercomchannel"><?php echo $I18N->msg('pushupdate_settings_pushercom_channel'); ?></label>
							<input type="text" value="<?php echo $REX['ADDON']['pushupdate']['settings']['pushercomchannel']; ?>" name="settings[pushercomchannel]" id="pushercomchannel" class="rex-form-text">
						</p>
					</div>
					<!--
					<div class="rex-form-row rex-form-element-v1">
						<p class="rex-form-text">
                            <pre>
                                &lt;script src="//js.pusher.com/2.2/pusher.min.js"&gt;&lt;/script&gt;
                                &lt;script&gt;
                                    var pu = Object.create(PUSHUPDATE);
                                    pu.initPusher({
                                        key: '<?php echo $REX['ADDON']['pushupdate']['settings']['pushercomappkey']; ?>',
                                        channel: '<?php echo $REX['ADDON']['pushupdate']['settings']['pushercomchannel']; ?>',
                                        callback: function(params) {
                                            //rexRT.log(this);
                                        }
                                    });
                                &lt;/script&gt;
                            </pre>
                        </p>
					</div>
                    -->
					<div class="rex-form-row rex-form-element-v1">
						<p class="rex-form-submit">
							<input type="submit" class="rex-form-submit" name="sendit" value="<?php echo $I18N->msg('pushupdate_settings_save'); ?>" />
						</p>
					</div>
				</div>
			</fieldset>
		</form>
	</div>
</div>



